Code segment word public "CODE"
       	assume cs:Code , ds:nothing

mystack segment para stack "STACK"
	db 512 dup(?)
mystack ends

BASE_8253 	equ 40h
TIMER_0_8253 	equ BASE_8253 + 0
MODE_8253	equ BASE_8253 + 3

OCW3	equ	20h
IRR	equ	20h

MPOPF macro
	local p1,p2
	jmp short p2
p1: iret
p2: push cs
	call p1
	endm

DELAY macro
	jmp $+2
	jmp $+2
	jmp $+2
	endm 

OutputStr	label byte
	db 0dh, 0ah, "Timed count: ",5 dup(?)

ASCIICountEnd	label byte
	db "microsec",0dh , 0ah
	db "$"


OriginalFlags	db	?
TimedCount	dw	?
ReferenceCount	dw	?
memvar		dw	?

start:
	mov cx,104857600 
	call ZTimerOn
Begin:
	dec cx
	push cx

	push cs   
	pop ds

	mov ax,[memvar]

	pop cx
	cmp cx,0
	jne Begin

	call ZTimerOff
	call ZTimerReport

	mov ah,4Ch
	int 21h

ZTimerOn proc near

	push ax
	pushf
	pop ax

	mov cs:[OriginalFlags], ah
	and ah,0fdh

	push ax

	sti

	mov al,00110100b
	out MODE_8253,al

	DELAY
	sub al,al
	out TIMER_0_8253,al
	DELAY
	out TIMER_0_8253,al

	rept 10
	jmp $+2
	endm

	cli
	
	mov al,00110100b
	out MODE_8253,al
	DELAY
	sub al,al
	out TIMER_0_8253,al
	DELAY
	out TIMER_0_8253,al

	MPOPF

	pop ax
	ret

ZTimerOn endp

ZTimerOff proc near

	push ax
	push cx
	pushf

	mov al,00000000b
	out MODE_8253,al

	in al,TIMER_0_8253
	DELAY
	mov ah,al
	in al,TIMER_0_8253
	xchg ah,al
	neg ax
	mov cs:[TimedCount],ax

	mov cs:[ReferenceCount],0
	mov cx,16
	cli

RefLoop:
	call ReferenceZTimerOn
	call ReferenceZTimerOff
	loop RefLoop
	sti
	add cs:[ReferenceCount],8
	mov cl,4
	shr cs:[ReferenceCount],cl

	pop ax

	mov ch,cs:[OriginalFlags]
	and ch,not 0fdh
	and ah,0fdh
	or  ah,ch
	push ax

	MPOPF

	pop cx
	pop ax
	ret

ZTimerOff endp

ReferenceZTimerOn proc near

	push ax
	pushf

	mov al,00110100b
	out MODE_8253,al
	DELAY

	sub al,al
	out TIMER_0_8253,al
	DELAY
	out TIMER_0_8253,al

	MPOPF

	pop ax
	ret

ReferenceZTimerOn endp

ReferenceZTimerOff proc near

	push ax
	push cx
	pushf

	mov al,00000000b
	out MODE_8253,al
	DELAY
	in al,TIMER_0_8253
	DELAY
	mov ah,al
	in al,TIMER_0_8253
	xchg ah,al
	neg ax
	add cs:[ReferenceCount],ax

	MPOPF
	pop cx
	pop ax
	ret

ReferenceZTimerOff endp

ZTimerReport proc near

	pushf
	push ax
	push bx
	push cx
	push dx
	push si
	push ds

	push cs
	pop ds
	assume ds:Code

	mov ax,[TimedCount]
	sub ax,[ReferenceCount]
	mov si,offset ASCIICountEnd - 1

	mov dx,8381
	mul dx
	mov bx,10000
	div bx

	push ax
	mov bx,di
	adc ax,bx
	mov di,ax
	pop ax

	mov bx,10
	mov cx,5

CTSLoop:
	sub dx,dx
	div bx
	add dl,"0"
	mov [si],dl
	dec si
	loop CTSLoop

	mov ah,9
	mov dx,offset OutputStr
	int 21h

	pop ds
	pop si
	pop dx
	pop cx
	pop bx
	pop ax
	MPOPF
	ret

ZTimerReport endp

Code ends
	end start	
	